#include "dialog.h"
#include "ui_dialog.h"
#include <QMessageBox>

Dialog::Dialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::Dialog)
{
    ui->setupUi(this);
    setWindowFlags(windowFlags()^Qt::WindowContextHelpButtonHint);
}

Dialog::~Dialog()
{
    delete ui;
}

void Dialog::MsgBox(QString msg)
{
    QMessageBox box;  // #include <QMessageBox> nicht vergessen!
    box.setText(msg);
    box.exec();
}

void Dialog::on_b_matlab_clicked()
{
    matlab.setControl("MATLAB.Application");
    if(matlab.isNull()) { MsgBox("MATLAB kann nicht gestartet werden!"); return; }

    // 2x2-Matrix aufbauen
    QList<QVariant> row, mat_a;
    row.push_back(1.1); row.push_back(2.2); mat_a.push_back(row); row.clear();
    row.push_back(3.3); row.push_back(4.4); mat_a.push_back(row); row.clear();

    // Matrix nach MATLAB senden
    matlab.dynamicCall("PutWorkspaceData(QString,QString,QVariant)", "a", "base", mat_a);

    // MATLAB-Befehle ausführen
    matlab.dynamicCall("Execute(QString)", "a = cell2mat(a)");
    matlab.dynamicCall("Execute(QString)", "b = 2 * a");
    matlab.dynamicCall("Execute(QString)", "b = num2cell(b)");

    // Matrix von MATLAB empfangen
    QString msg = "Matrix b:\n\n";
    auto mat_b = matlab.dynamicCall("GetVariable(QString,QString)", "b", "base");

    // Alle empfangenen Zeilen durchlaufen...
    for(auto single_row : mat_b.toList())
    {
        // Alle Elemente innerhalb der aktuellen Zeile...
        for(auto single_element : single_row.toList())
            msg += single_element.toString() + " ";
        msg += "\n";
    }
    MsgBox(msg);
}
